export declare class Graph {
    private nodes;
    private outgoingEdges;
    private incomingEdges;
    addNode(node: Node): void;
    removeNode(name: string): void;
    hasNode(name: string): boolean;
    readonly size: number;
    getNode(name: string): Node;
    /**
     * "from" is dependent on "to"
     */
    addDependency(from: string, to: string): void;
    removeDependency(from: string, to: string): void;
    dependenciesOf(name: string): string[];
    dependentsOf(name: string): string[];
    /**
     * Breadth first search.
     */
    traverse(): Promise<any[]>;
    /**
     * Clears the value of a node and the values of dependent nodes
     */
    clearNodeAndDependents(name: string): Promise<any>;
    reset(): void;
    ls(): void;
}
export declare class Node {
    private _name;
    private _promise;
    private _data?;
    private mutex?;
    private locked;
    constructor(name: string, promise: () => Promise<any>);
    readonly name: string;
    awaitData(): Promise<any>;
    signalDependenciesReady(): void;
    setData(data: any): void;
    reset(): void;
    clearMutex(): void;
    hasData(): boolean;
    clearData(): void;
}
